/**
 * 
 */
/**
 * @author Administrator
 *
 */
package com.baofoo.Demo;

import java.util.HashMap;
import java.util.Map;
import java.util.TreeMap;

import com.baofoo.rsa.RsaCodingUtil;
import com.baofoo.util.HttpUtil;
import com.baofoo.util.JXMConvertUtil;
import com.baofoo.util.Log;
import com.baofoo.util.SecurityUtil;

import net.sf.json.JSONObject;

/**
 * 账户余额查询
 * @author dasheng
 * @date 2023年3月9日
 *
 */
public class T_1001_006_03{
	public static void main(String[] args) throws Exception {

		String  member_id = "100029078";//商户号
	    String  terminal_id = "200004282";//终端号	      
	    String  pfxpath = "D:\\CER_EN_DECODE\\AgreementPay\\TestAgr\\bfkey_100029078@@200004282.pfx";//商户私钥        
	    String  cerpath = "D:\\CER_EN_DECODE\\AgreementPay\\TestAgr\\bfkey_100029078@@200004282.cer";//宝付公钥
	    String  pfxPwd="123456";//商户私钥密码
	    
	    
	    /* Header 参数*/
		Map<String,String> HeaderPost = new HashMap<String,String>();
	    HeaderPost.put("memberId", member_id);//宝付提供给商户的唯一编号
		HeaderPost.put("terminalId", terminal_id);
		HeaderPost.put("serviceTp", "T-1001-006-03");//信用卡还款下单接口
		HeaderPost.put("verifyType", "1");//加密方式目前只有1种，请填：1
        
        Map<String,Object> BodyData = new TreeMap<String,Object>();       
   		BodyData.put("version", "4.0.0");//版本号
   		BodyData.put("accountType", "BASE_ACCOUNT");//BASE_ACCOUNT:基本户  FREEZE_ACCOUNT:冻结户     	
        
        Map<String,Object> contentData = new TreeMap<String,Object>();        
        contentData.put("header", HeaderPost);
        contentData.put("body", BodyData);
        
		JSONObject jsonObjectFromMap = JSONObject.fromObject(contentData);
		String Jsonstr = jsonObjectFromMap.toString();
		Log.Write("序列化："+ Jsonstr);
		
		String base64str = SecurityUtil.Base64Encode(Jsonstr);
		String data_content = RsaCodingUtil.encryptByPriPfxFile(base64str,pfxpath,pfxPwd);	
		HeaderPost.put("content", data_content);

		String Urlstring = "https://vgw.baofoo.com/union-gw/api/";
		String PostString  = HttpUtil.RequestForm(Urlstring+HeaderPost.get("serviceTp")+"/transReq.do", HeaderPost);	
		Log.Write("请求返回："+ PostString);
		
		
		 PostString = RsaCodingUtil.decryptByPubCerFile(PostString,cerpath);
		 if(PostString.isEmpty()){//判断解密是否正确。如果为空则宝付公钥不正确
			Log.Write("=====检查解密公钥是否正确！");
			throw new Exception("Decryption is incorrect!");
		 }
		 PostString = SecurityUtil.Base64Decode(PostString);		 
		 Log.Write("=====返回查询数据解密结果:"+PostString);
		 
		 
		 Map<String,Object> ArrayData = JXMConvertUtil.JsonConvertHashMap(PostString);//此处方法不建议商户使用。请使用其他反序列化方法，此处只为DEMO演示方便使用
		 
		 Log.Write("arrydata:"+ArrayData.toString());
		 
		 if(!ArrayData.containsKey("sysRespCode")){
			 throw new Exception("sysRespCode Not Found Key [sysRespCode]!");
		 }		 
		 Log.Write("sysRespCode:"+ArrayData.get("sysRespCode").toString());
		 
		 if(ArrayData.get("sysRespCode").toString().equals("S_0000")){
			 if(!ArrayData.containsKey("retCode")){
				 throw new Exception("state Not Found Key [retCode]!");
			 }
			 
			 if(ArrayData.get("retCode").toString().equals("1")){
				 Log.Write("查询成功！");
			 }
			 Log.Write("retCode:"+ArrayData.get("retCode").toString());
		 }
  
	}
}